# -*- coding: utf-8 -*-
# pylint: disable-msg = C0103, W0612, W0703
#
# Copyright 2004-2006 André Malo or his licensors, as applicable
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
"""
Testcases for svnmailer.notifier.cia_xmlrpc

@var _tests: The test classes
@type _tests: C{list}
"""
__author__    = "André Malo"
__docformat__ = "epytext en"
__all__       = ['getSuite']

import unittest
_tests = []


class importTestCase(unittest.TestCase):
    """ Importing svnmailer.notifier.cia_xmlrpc """

    def testImport(self):
        """ from svnmailer.notifier import cia_xmlrpc """
        try:
            from svnmailer.notifier import cia_xmlrpc
        except Exception, exc:
            self.fail(
                "svnmailer.notifier.cia_xmlrpc could not be imported: %s" %
                str(exc)
            )

_tests.append(importTestCase)


class CIAXMLRPCNotifierTestCase(unittest.TestCase):
    """ svnmailer.notifier.cia_xmlrpc.CIAXMLRPCNotifier """

    def setUp(self):
        """ Create test environment """
        from svnmailer.notifier import cia_xmlrpc
        self._cia = cia_xmlrpc
        self._settings = DummyContainer(
            runtime = DummyContainer(),
            general = DummyContainer(),
            groups  = []
        )
        self._config = DummyContainer()

_tests.append(CIAXMLRPCNotifierTestCase)


class DummyContainer(object):
    def __init__(self, **kwargs):
        self._dict = kwargs
    def __getattr__(self, name):
        return self._dict.get(name)


#### Glue code                                      ####
########################################################
__all__.extend(_tests)

def getSuite():
    """ Returns the test suite for this module """
    return unittest.TestSuite([
        unittest.makeSuite(test) for test in _tests
    ])

if __name__ == '__main__':
    unittest.TextTestRunner(verbosity = 2).run(getSuite())
